local mod = ...



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Aladdin1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Aladdin2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Assets -------------------------------------------------------------------------------------
mod:registerAssetId("models/Aladdin1.fbx/Prefab/CorePart", "PREFAB_ALADDIN_CORE")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/RemoverPart1", "PREFAB_ALADDIN_REMOVER1")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/RemoverPart2", "PREFAB_ALADDIN_REMOVER2")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/RemoverPart3", "PREFAB_ALADDIN_REMOVER3")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/RemoverPart4", "PREFAB_ALADDIN_REMOVER4")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/BerryBasketPart", "PREFAB_ALADDIN_BASKET_BERRIES")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/BreadBasketPart", "PREFAB_ALADDIN_BASKET_BREAD")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/FishBasketPart", "PREFAB_ALADDIN_BASKET_FISH")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/ClothesCratePart", "PREFAB_ALADDIN_CRATES_CLOTHES")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/HoneyPotPart", "PREFAB_ALADDIN_POT_HONEY")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/GoldChestPart", "PREFAB_ALADDIN_CHEST_GOLD")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/CrossPart", "PREFAB_ALADDIN_CROSS")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/PumpkinPart", "PREFAB_ALADDIN_PUMPKIN")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/VillageCentrePart", "PREFAB_ALADDIN_VILLAGECENTRE")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/SecurityPart", "PREFAB_ALADDIN_SECURITY")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/AuthorityPart", "PREFAB_ALADDIN_AUTHORITY")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/EntertainmentPart", "PREFAB_ALADDIN_ENTERTAINMENT")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/StonePart", "PREFAB_ALADDIN_STONE")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/WoodPart", "PREFAB_ALADDIN_WOOD")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/CoalPart", "PREFAB_ALADDIN_COAL")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/ToolPart", "PREFAB_ALADDIN_TOOL")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/PlankPart", "PREFAB_ALADDIN_PLANK")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/ResidentialPart", "PREFAB_ALADDIN_RESIDENTIAL")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/WheelPart", "PREFAB_ALADDIN_WHEEL")

mod:registerAssetId("models/Aladdin2.fbx/Prefab/CratePart", "PREFAB_ALADDIN_RESOURCE_CRATES")

for i = 1, 5 do
    mod:registerAssetId("models/Aladdin2.fbx/Prefab/Function." .. string.sub("000" .. i, -3), "PREFAB_ALADDIN_RESOURCE_" .. i)
    mod:registerPrefabComponent("models/Aladdin2.fbx/Prefab/Function." .. string.sub("000" .. i, -3), { DataType = "COMP_BUILDING_PART" })
end



-- Comp Building Part -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Aladdin1.fbx/Prefab/VillageCentrePart", { DataType = "COMP_BUILDING_PART" })



-- Material -------------------------------------------------------------------------------------
mod:registerAssetId("models/Aladdin1.fbx/Materials/bush", "BUSH_LEAVES")
mod:override({
    Id = "BUSH_LEAVES",
	HasAlphaTest = true,
	BackFaceVisible = true
})



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
-- mod:configurePrefabFlagList("models/Health1.fbx/Prefab/HospitalPart", { "PLATFORM" })



-- Grounding  -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent("models/Health1.fbx/Prefab/DoorPart", { DataType = "COMP_GROUNDED" })



-- Building: Aladdin -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_ALADDIN",
	Name = "BUILDING_ALADDIN_NAME",
	Description = "BUILDING_ALADDIN_DESC",
    BuildingType = "MODS",
    AssetCoreBuildingPart = "BUILDING_PART_ALADDIN_CORE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_PART_SET_ALADDIN_4",
			BuildingPartList = { 
                "BUILDING_PART_ALADDIN_INFINITE_GOLD",
                "BUILDING_PART_ALADDIN_INFINITE_RESOURCE",
                "BUILDING_PART_ALADDIN_IMMIGRATION",
                "BUILDING_PART_ALADDIN_RESIDENTIAL",
            }
		},
		{
			Name = "BUILDING_PART_SET_ALADDIN_2",
			BuildingPartList = { 
                "BUILDING_PART_ALADDIN_BERRY",
                "BUILDING_PART_ALADDIN_STONE",
                "BUILDING_PART_ALADDIN_FISH",
                -- "BUILDING_PART_ALADDIN_MINERAL1",
                -- "BUILDING_PART_ALADDIN_MINERAL2",
                -- "BUILDING_PART_ALADDIN_MINERAL3",
                -- trees cause crashes if placed more than one
                -- "BUILDING_PART_ALADDIN_OAK",
                -- "BUILDING_PART_ALADDIN_SYCAMORE",
                -- "BUILDING_PART_ALADDIN_POPLAR",
                -- "BUILDING_PART_ALADDIN_PINE",
            }
		},
		-- {
		-- 	Name = "BUILDING_PART_SET_ALADDIN_3",
		-- 	BuildingPartList = { 
        --         -- "BUILDING_PART_ALADDIN_INFINITE_BERRY",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_BREAD",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_FISH",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_CLOTHES",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_HONEY",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_STONE",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_WOOD",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_PLANK",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_COAL",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_TOOL",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_FAITH",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_SECURITY",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_AUTHORITY",
        --         -- "BUILDING_PART_ALADDIN_INFINITE_ENTERTAINMENT",
        --     }
		-- },
		{
			Name = "BUILDING_PART_SET_ALADDIN_1",
			BuildingPartList = { 
                "BUILDING_PART_ALADDIN_REMOVER2",
                "BUILDING_PART_ALADDIN_REMOVER3",
                "BUILDING_PART_ALADDIN_REMOVER4",
                "BUILDING_PART_ALADDIN_REMOVER1",
                "BUILDING_PART_ALADDIN_VILLAGECENTRE",
            }
		},
	},	
	IsEditable = true
})



-- Building Part: Core -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_CORE",
	Name = "BUILDING_PART_ALADDIN_CORE_NAME",
    Description = "BUILDING_ALADDIN_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_CORE"
    }, 
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.5, {0, 0}, 12 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
		}
	}
})



-- Building Part: Remover 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_REMOVER1",
	Name = "BUILDING_PART_ALADDIN_REMOVER1_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_REMOVER1"
    },
	DesirabilityModifiers = {
		{
			Desirability = "DESIRABILITY_RESIDENTIAL",
			Type = "SUBSTRACT",
			Radius = 10,
			Value = 0
		}
	}
})



-- Custom Component: Remover 1 (berries and stone) -------------------------------------------------------------------------------------
local COMP_ALADDIN_REMOVER1 = {
	TypeName = "COMP_ALADDIN_REMOVER1",
	ParentType = "COMPONENT"
}

function COMP_ALADDIN_REMOVER1:update()

    -- Find and remove stone or berry bushes within radius
    objlist = {}
    local pos1 = self:getOwner():getGlobalPosition()

    self:getLevel():getComponentManager("COMP_RESOURCE_CONTAINER"):getAllEnabledComponent():forEach(function(compContainer)
        local compName = compContainer.ResourceData.ResourceName
        if (compName) then
            -- mod:log(tostring(compName))
            if (tostring(compName) == "BERRIES" or tostring(compName) == "STONES") then
                local compPart = compContainer:getOwner():getComponent("COMP_BUILDING_PART")
                if (not compPart) then -- do not delete if the resource container is part of a building
                    local pos2 = compContainer:getOwner():getGlobalPosition()
                    local distance = math.sqrt( (pos1.x - pos2.x)^2 + (pos1.z - pos2.z)^2 )
                    if (distance <= 10) then
                        -- insert the object ID into the table
                        if (tostring(compName) == "BERRIES") then -- you have to delete the parent otherwise the bushes come back the next reload
                            table.insert(objlist, 1, compContainer:getOwner():getParent():getId())
                        else -- STONE, for some reason it has a different level and if you delete the parent of the object occasionally you get a crash
                            table.insert(objlist, 1, compContainer:getOwner():getId())
                        end
                    end
                end
            end
        end
    end)

    -- Destroy the objects
    if (#objlist > 0) then
        local iObj = #objlist
        for i=1, iObj, 1 do
            local objtarget = self:getLevel():find(tostring(objlist[i]))
            if (objtarget) then 
                objtarget:destroyAllChild()
                objtarget:destroy()
            end
        end
    end

    -- Destroy the building part that was used to remove the resources
	self:getOwner():destroyAllChild()
	self:getOwner():destroy()

end

mod:registerClass(COMP_ALADDIN_REMOVER1)
mod:registerPrefabComponent("PREFAB_ALADDIN_REMOVER1", { DataType = "COMP_ALADDIN_REMOVER1" } )



-- Building Part: Remover 2 (trees, circle) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_REMOVER2",
	Name = "BUILDING_PART_ALADDIN_REMOVER2_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_REMOVER2"
    },
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 5, {0, 0}, 24 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
		}
	}
})



-- Building Part: Remover 3 (trees, square) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_REMOVER3",
	Name = "BUILDING_PART_ALADDIN_REMOVER3_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_REMOVER3"
    },
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {5, 5}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
		}
	}
})



-- Building Part: Remover 4 (trees, rectangle) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_REMOVER4",
	Name = "BUILDING_PART_ALADDIN_REMOVER4_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_REMOVER4"
    },
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2.5, 7.5}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
		}
	}
})



-- Custom Component: Remover 2 (trees) -------------------------------------------------------------------------------------
local COMP_ALADDIN_REMOVER2 = {
	TypeName = "COMP_ALADDIN_REMOVER2",
	ParentType = "COMPONENT"
}

function COMP_ALADDIN_REMOVER2:update()

    -- Destroy the building part that was used to remove the trees
	self:getOwner():destroyAllChild()
	self:getOwner():destroy()

end

mod:registerClass(COMP_ALADDIN_REMOVER2)
mod:registerPrefabComponent("PREFAB_ALADDIN_REMOVER2", { DataType = "COMP_ALADDIN_REMOVER2" } )
mod:registerPrefabComponent("PREFAB_ALADDIN_REMOVER3", { DataType = "COMP_ALADDIN_REMOVER2" } )
mod:registerPrefabComponent("PREFAB_ALADDIN_REMOVER4", { DataType = "COMP_ALADDIN_REMOVER2" } )



-- Building Part: Any Resource -------------------------------------------------------------------------------------
function RegisterAladdinResource(resource)
    mod:register({
        DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
        Id = "BUILDING_FUNCTION_ALADDIN_RESOURCE_" .. resource,
        Name = "BUILDING_FUNCTION_ALADDIN_RESOURCE_" .. resource .. "_NAME",
        ResourceGenerated = resource,
        IsForConsumer = true,
        IsInfinite = true
    })
end

RegisterAladdinResource("BARREL")
RegisterAladdinResource("BEER")
RegisterAladdinResource("BERRIES")
RegisterAladdinResource("BOAR")
RegisterAladdinResource("BREAD")
RegisterAladdinResource("CHEESE")
RegisterAladdinResource("CLOTHES")
RegisterAladdinResource("COAL")
RegisterAladdinResource("FAITH")
RegisterAladdinResource("FISH")
RegisterAladdinResource("FLOUR")
RegisterAladdinResource("GEMS")
RegisterAladdinResource("GLASS")
RegisterAladdinResource("GOLD_BARS")
RegisterAladdinResource("GOLD_ORE")
RegisterAladdinResource("GRAPES")
RegisterAladdinResource("HERBS")
RegisterAladdinResource("HONEY")
RegisterAladdinResource("HOP")
RegisterAladdinResource("IRON")
RegisterAladdinResource("IRON_ORE")
RegisterAladdinResource("JEWELRY")
RegisterAladdinResource("MARBLE")
RegisterAladdinResource("MEAL")
RegisterAladdinResource("MILK")
RegisterAladdinResource("PLANK")
RegisterAladdinResource("POLISHED_STONE")
RegisterAladdinResource("QUARTZ")
RegisterAladdinResource("SCULPTURE")
RegisterAladdinResource("SPEAR")
RegisterAladdinResource("STAINED_GLASS")
RegisterAladdinResource("STONE")
RegisterAladdinResource("SWORD")
RegisterAladdinResource("TOOL")
RegisterAladdinResource("WATER")
RegisterAladdinResource("WHEAT")
RegisterAladdinResource("WINE")
RegisterAladdinResource("WOOD")
RegisterAladdinResource("WOOL")
RegisterAladdinResource("WOOLEN_CLOTH")


-- Assignable
mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_ALADDIN_RESOURCE",
	AssetFunctionList = {
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_BARREL",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_BEER",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_BERRIES",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_BOAR",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_BREAD",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_CHEESE",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_CLOTHES",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_COAL",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_FAITH",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_FISH",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_FLOUR",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_GEMS",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_GLASS",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_GOLD_BARS",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_GOLD_ORE",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_GRAPES",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_HERBS",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_HONEY",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_HOP",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_IRON",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_IRON_ORE",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_JEWELRY",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_MARBLE",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_MEAL",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_MILK",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_PLANK",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_POLISHED_STONE",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_QUARTZ",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_SCULPTURE",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_SPEAR",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_STAINED_GLASS",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_STONE",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_SWORD",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_TOOL",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_WATER",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_WHEAT",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_WINE",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_WOOD",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_WOOL",
        "BUILDING_FUNCTION_ALADDIN_RESOURCE_WOOLEN_CLOTH",
    }
})

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_ALADDIN_RESOURCE",
	Name = "BUILDING_FUNCTION_ASSIGNABLE_ALADDIN_RESOURCE_NAME",
	AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_ALADDIN_RESOURCE"
})


-- Slots
for i = 1, 5 do
    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_ALADDIN_RESOURCE_" .. i,
        Name = "BUILDING_PART_ALADDIN_RESOURCE_NAME",
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_ALADDIN_RESOURCE_" .. i
        },
        AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_ALADDIN_RESOURCE",
    })
end

-- Assemblage
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_RESOURCE_ASSEMBLAGE",
	Name = "BUILDING_PART_ALADDIN_RESOURCE_ASSEMBLAGE_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_ALADDIN_RESOURCE_CRATES" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_ALADDIN_RESOURCE_1", OptionalAttachNodeString = "Attach_Major.001" },
			{ BuildingPart = "BUILDING_PART_ALADDIN_RESOURCE_2", OptionalAttachNodeString = "Attach_Major.002" },
			{ BuildingPart = "BUILDING_PART_ALADDIN_RESOURCE_3", OptionalAttachNodeString = "Attach_Major.003" },
			{ BuildingPart = "BUILDING_PART_ALADDIN_RESOURCE_4", OptionalAttachNodeString = "Attach_Major.004" },
			{ BuildingPart = "BUILDING_PART_ALADDIN_RESOURCE_5", OptionalAttachNodeString = "Attach_Major.005" },
			-- { BuildingPart = "BUILDING_PART_ALADDIN_RESOURCE_6" },
			-- { BuildingPart = "BUILDING_PART_ALADDIN_RESOURCE_7" },
			-- { BuildingPart = "BUILDING_PART_ALADDIN_RESOURCE_8" },
			-- { BuildingPart = "BUILDING_PART_ALADDIN_RESOURCE_9" },
			-- { BuildingPart = "BUILDING_PART_ALADDIN_RESOURCE_10" },
		}
	},
})

-- Random
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_RESOURCE",
	Name = "BUILDING_PART_ALADDIN_INFINITE_RESOURCE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_ALADDIN_RESOURCE_ASSEMBLAGE",
        },
    },
	BuildingZone = {
		-- ZoneEntryList = {
		-- 	{
		-- 		Polygon = polygon.createCircle( 1.2, {0, 0}, 12 ),
		-- 		Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
		-- 	},
		-- }
	},
    Cost = {
    },
})



-- Building Part: Berry -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_BERRY",
	Name = "BUILDING_PART_ALADDIN_BERRY_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_RESOURCE_BERRIES"
    }
})



-- Building Part: Stone -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_STONE",
	Name = "BUILDING_PART_ALADDIN_STONE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_RESOURCE_ROCK"
    }
})



-- Building Part: Fish -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_FISH",
	Name = "BUILDING_PART_ALADDIN_FISH_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_RESOURCE_FISH"
    }
})



-- Custom Component: resources -------------------------------------------------------------------------------------
-- This is to prevent a crash that occurs if you place a resource container in water, but 
-- the resource is not set up to be in water. On reloading the game it causes a crash. To avoid,
-- I remove the building part component from the resource which seems to avoid the crash.

local COMP_ALADDIN_RESOURCE = {
	TypeName = "COMP_ALADDIN_RESOURCE",
	ParentType = "COMPONENT"
}

function COMP_ALADDIN_RESOURCE:update()

    -- Remove building part component
    compPart = self:getOwner():getComponent("COMP_BUILDING_PART")
    if (compPart) then
        self:getOwner():removeComponent(compPart)
        -- mod:log("Aladdin: Building part removed from resource.")
    end

    -- Remove this component
    obj = self:getOwner()
    obj:removeComponent(self)
    -- mod:log("Aladdin: Resource component removed.")


end

mod:registerClass(COMP_ALADDIN_RESOURCE)
mod:registerPrefabComponent("PREFAB_RESOURCE_BERRIES", { DataType = "COMP_ALADDIN_RESOURCE" } )
mod:registerPrefabComponent("PREFAB_RESOURCE_ROCK", { DataType = "COMP_ALADDIN_RESOURCE" } )
mod:registerPrefabComponent("PREFAB_RESOURCE_FISH", { DataType = "COMP_ALADDIN_RESOURCE" } )



-- -- Building Part: Mineral 1 -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_MINERAL1",
-- 	Name = "BUILDING_PART_ALADDIN_MINERAL1_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_MINERAL_SOURCE_1"
--     }
-- })

-- -- Custom Component: Mineral 1 -------------------------------------------------------------------------------------
-- local COMP_ALADDIN_MINERAL1 = {
-- 	TypeName = "COMP_ALADDIN_MINERAL1",
-- 	ParentType = "COMPONENT"
-- }

-- function COMP_ALADDIN_MINERAL1:onEnabled()

--     mod:log(tostring(self))
--     local compPart = self:getOwner():getComponent("COMP_BUILDING_PART")
--     if (compPart) then

--         -- Record position of the placed building part
--         local pos1 = self:getOwner():getGlobalPosition()
--         local orient1 = self:getOwner():getGlobalOrientation()

--         -- Add an identical prefab to the same spot
--         prefabNew = self:getLevel():createObject("PREFAB_MINERAL_SOURCE_1", pos1, orient1)

--         -- Remove the building part that initiated this change
--         self:getOwner():destroyAllChild()
--         self:getOwner():destroy()

--     -- else

--     --     local comp = self:getOwner():getComponent("COMP_ALADDIN_MINERAL1")
--     --     if (comp) then
--     --         self:getOwner():removeComponent(comp)
--     --     end

--     end

-- end

-- mod:registerClass(COMP_ALADDIN_MINERAL1)
-- mod:registerPrefabComponent("PREFAB_MINERAL_SOURCE_1", { DataType = "COMP_ALADDIN_MINERAL1" } )



-- -- Building Part: Mineral 2 -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_MINERAL2",
-- 	Name = "BUILDING_PART_ALADDIN_MINERAL2_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_MINERAL_SOURCE_2"
--     }
-- })

-- -- Custom Component: Mineral 2 -------------------------------------------------------------------------------------
-- local COMP_ALADDIN_MINERAL2 = {
-- 	TypeName = "COMP_ALADDIN_MINERAL2",
-- 	ParentType = "COMPONENT"
-- }

-- function COMP_ALADDIN_MINERAL2:update()

--     -- local compPart = self:getOwner():getComponent("COMP_BUILDING_PART")
--     -- if (not compPart) then -- this is a native mineral node, destroy this component

--     --     self:getOwner():getComponent("COMP_ALADDIN_MINERAL3"):destroy()

--     -- else

--     --     -- Record position of the placed building part
--     --     local pos1 = self:getOwner():getGlobalPosition()
--     --     local orient1 = self:getOwner():getGlobalOrientation()

--     --     -- Add an identical prefab to the same spot
--     --     prefabNew = self:getLevel():createObject("PREFAB_MINERAL_SOURCE_2", pos1, orient1)

--     --     -- Destroy the building part that was used to create the node
--     --     self:getOwner():destroyAllChild()
--     --     self:getOwner():destroy()

--     -- end

--     local compPart = self:getOwner():getComponent("COMP_BUILDING_PART")
--     if (compPart) then

--         -- Record position of the placed building part
--         local pos1 = self:getOwner():getGlobalPosition()
--         local orient1 = self:getOwner():getGlobalOrientation()

--         -- Add an identical prefab to the same spot
--         prefabNew = self:getLevel():createObject("PREFAB_MINERAL_SOURCE_2", pos1, orient1)

--     end

--     -- Destroy the building part that was used to create the node
--     self:destroy()

-- end

-- mod:registerClass(COMP_ALADDIN_MINERAL2)
-- mod:registerPrefabComponent("PREFAB_MINERAL_SOURCE_2", { DataType = "COMP_ALADDIN_MINERAL2" } )



-- -- Building Part: Mineral 3 -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_MINERAL3",
-- 	Name = "BUILDING_PART_ALADDIN_MINERAL3_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_MINERAL_SOURCE_3"
--     }
-- })

-- -- Custom Component: Mineral 3 -------------------------------------------------------------------------------------
-- local COMP_ALADDIN_MINERAL3 = {
-- 	TypeName = "COMP_ALADDIN_MINERAL3",
-- 	ParentType = "COMPONENT"
-- }

-- function COMP_ALADDIN_MINERAL3:update()

--     local compPart = self:getOwner():getComponent("COMP_BUILDING_PART")
--     if (compPart) then

--         -- Record position of the placed building part
--         local pos1 = self:getOwner():getGlobalPosition()
--         local orient1 = self:getOwner():getGlobalOrientation()

--         -- Add an identical prefab to the same spot
--         prefabNew = self:getLevel():createObject("PREFAB_MINERAL_SOURCE_3", pos1, orient1)
--         self:destroy()

--     else
--         self:destroy()
--     end


-- end

-- mod:registerClass(COMP_ALADDIN_MINERAL3)
-- mod:registerPrefabComponent("PREFAB_MINERAL_SOURCE_3", { DataType = "COMP_ALADDIN_MINERAL3" } )



-- -- Building Part: Oak -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_OAK",
-- 	Name = "BUILDING_PART_ALADDIN_OAK_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_TREE_OAK"
--     }
-- })



-- -- Building Part: Sycamore -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_SYCAMORE",
-- 	Name = "BUILDING_PART_ALADDIN_SYCAMORE_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_TREE_SYCAMORE"
--     }
-- })



-- -- Building Part: Poplar -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_POPLAR",
-- 	Name = "BUILDING_PART_ALADDIN_POPLAR_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_TREE_POPLAR"
--     }
-- })



-- -- Building Part: Pine -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_PINE",
-- 	Name = "BUILDING_PART_ALADDIN_PINE_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_TREE_PINE"
--     }
-- })



-- Building Part: Infinite Gold -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_GOLD",
	Name = "BUILDING_PART_ALADDIN_INFINITE_GOLD_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_CHEST_GOLD"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_GOLD",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {0.5, 0.7}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_GOLD",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_GOLD_NAME",
    ResourceGenerated = "GOLD_COINS",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Berries -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_BERRY",
	Name = "BUILDING_PART_ALADDIN_INFINITE_BERRY_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_BASKET_BERRIES"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_BERRY",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.3, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_BERRY",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_BERRY_NAME",
    ResourceGenerated = "BERRIES",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Bread -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_BREAD",
	Name = "BUILDING_PART_ALADDIN_INFINITE_BREAD_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_BASKET_BREAD"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_BREAD",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.4, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_BREAD",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_BREAD_NAME",
    ResourceGenerated = "BREAD",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Fish -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_FISH",
	Name = "BUILDING_PART_ALADDIN_INFINITE_FISH_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_BASKET_FISH"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_FISH",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.4, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_FISH",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_FISH_NAME",
    ResourceGenerated = "FISH",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Clothes -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_CLOTHES",
	Name = "BUILDING_PART_ALADDIN_INFINITE_CLOTHES_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_CRATES_CLOTHES"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_CLOTHES",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.6, 1.6}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_CLOTHES",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_CLOTHES_NAME",
    ResourceGenerated = "CLOTHES",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Honey -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_HONEY",
	Name = "BUILDING_PART_ALADDIN_INFINITE_HONEY_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_POT_HONEY"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_HONEY",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.4, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_HONEY",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_HONEY_NAME",
    ResourceGenerated = "HONEY",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Faith -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_FAITH",
	Name = "BUILDING_PART_ALADDIN_INFINITE_FAITH_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_CROSS"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_FAITH",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1, 1}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_FAITH",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_FAITH_NAME",
    ResourceGenerated = "FAITH",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Stone -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_STONE",
	Name = "BUILDING_PART_ALADDIN_INFINITE_STONE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_STONE"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_STONE",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.2, 1.2}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_STONE",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_STONE_NAME",
    ResourceGenerated = "STONE",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Wood -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_WOOD",
	Name = "BUILDING_PART_ALADDIN_INFINITE_WOOD_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_WOOD"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_WOOD",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.4, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_WOOD",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_WOOD_NAME",
    ResourceGenerated = "WOOD",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Planks -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_PLANK",
	Name = "BUILDING_PART_ALADDIN_INFINITE_PLANK_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_PLANK"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_PLANK",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {0.8, 1.2}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_PLANK",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_PLANK_NAME",
    ResourceGenerated = "PLANK",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Coal -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_COAL",
	Name = "BUILDING_PART_ALADDIN_INFINITE_COAL_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_COAL"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_COAL",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.2, 1.2}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_COAL",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_COAL_NAME",
    ResourceGenerated = "COAL",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Tool -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_TOOL",
	Name = "BUILDING_PART_ALADDIN_INFINITE_TOOL_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_TOOL"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_TOOL",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.4, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_TOOL",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_TOOL_NAME",
    ResourceGenerated = "TOOL",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Security -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_SECURITY",
	Name = "BUILDING_PART_ALADDIN_INFINITE_SECURITY_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_SECURITY"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_SECURITY",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.4, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_SECURITY",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_SECURITY_NAME",
    ResourceGenerated = "RESOURCE_SECURITY",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Authority -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_AUTHORITY",
	Name = "BUILDING_PART_ALADDIN_INFINITE_AUTHORITY_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_AUTHORITY"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_AUTHORITY",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.4, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_AUTHORITY",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_AUTHORITY_NAME",
    ResourceGenerated = "RESOURCE_AUTHORITY",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Entertainment -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_ENTERTAINMENT",
	Name = "BUILDING_PART_ALADDIN_INFINITE_ENTERTAINMENT_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_ENTERTAINMENT"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_ENTERTAINMENT",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.4, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_ENTERTAINMENT",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_ENTERTAINMENT_NAME",
    ResourceGenerated = "RESOURCE_ENTERTAINMENT",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Residential Desirability -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_RESIDENTIAL",
	Name = "BUILDING_PART_ALADDIN_RESIDENTIAL_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_RESIDENTIAL"
    },
    Category = "CORE",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.2, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	DesirabilityModifiers = {
		{
			Desirability = "DESIRABILITY_RESIDENTIAL",
			Type = "ADD",
			Radius = 30,
			Value = 1
		}
	}
})



-- Building Part: Immigration -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_IMMIGRATION",
	Name = "BUILDING_PART_ALADDIN_IMMIGRATION_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_WHEEL"
    },
})

-- define
local COMP_ALADDIN_IMMIGRATION = {
	TypeName = "COMP_ALADDIN_IMMIGRATION",
	ParentType = "COMPONENT",
	Properties = {
        -- { Name = "Active", Type = "boolean", Default = false, Flags = { "SAVE_GAME" } },
    }
}

-- update
function COMP_ALADDIN_IMMIGRATION:update()

    -- trigger immigration
    local compVillager = self:getLevel():getComponentManager("COMP_VILLAGER"):getFirstEnabled()
    local jobAsset = nil
    local jobWorkplace = nil
    if (compVillager) then

        local job = compVillager:getJobInstance()
        if (job) then
            jobAsset = job.AssetJob
            jobWorkplace = job.Workplace
        end

        compVillager:changeJob("JOB_ALADDIN_IMMIGRATION")
        mod:log("Triggering immigration wave")
        if (job) then
            if (jobWorkplace) then
                compVillager:changeJob(jobAsset, jobWorkplace)
            else
                compVillager:changeJob(jobAsset)
            end
        else
            compVillager:changeJob(nil)
        end

    end

    -- remove the prefab
	self:getOwner():destroyAllChild()
	self:getOwner():destroy()


end

-- Register
mod:registerClass(COMP_ALADDIN_IMMIGRATION)

-- Attach
mod:registerPrefabComponent("PREFAB_ALADDIN_WHEEL", { DataType = "COMP_ALADDIN_IMMIGRATION" } )



-- Building Part: Move Village Centre -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_VILLAGECENTRE",
	Name = "BUILDING_PART_ALADDIN_VILLAGECENTRE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_VILLAGECENTRE"
    },
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 5, {0.0, 0.0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	}
})

-- Custom Component: Village Centre -------------------------------------------------------------------------------------
local COMP_ALADDIN_VILLAGECENTRE = {
	TypeName = "COMP_ALADDIN_VILLAGECENTRE",
	ParentType = "COMPONENT"
}

function COMP_ALADDIN_VILLAGECENTRE:init()

    -- Move the village centre
    local pos1 = self:getOwner():getGlobalPosition()

	local part = self:getLevel():find("TempVillageCenterPart")
	local build = part:findFirstObjectWithComponentUp("COMP_BUILDING"):getOwner()

    -- Remove dirt circle
    comp = part:getParent():getComponent("COMP_DIRT_CIRCLE")
    part:getParent():removeComponent(comp)

    -- Move all child objects of the village centre
    build:forEachChild(function(child)
        child:setGlobalPosition(pos1)
    end)

    -- mod:log(tostring(part:getParent()))
    -- part:getParent():forEachComponent(function(comp)
    --     mod:log(tostring(comp))
    -- end)

end

function COMP_ALADDIN_VILLAGECENTRE:update()

    -- Delete the building part used to move the village centre
    self:getOwner():destroyAllChild()
    self:getOwner():destroy()

end

mod:registerClass(COMP_ALADDIN_VILLAGECENTRE)
mod:registerPrefabComponent("PREFAB_ALADDIN_VILLAGECENTRE", { DataType = "COMP_ALADDIN_VILLAGECENTRE" } )
