local mod = ...



-- Job: Event Trigger -------------------------------------------------------------------------------------
mod:register({
    DataType = "JOB",
    Id = "JOB_ALADDIN_IMMIGRATION",
    JobName = "JOB_ALADDIN_IMMIGRATION_NAME",
    JobDescription = "JOB_ALADDIN_IMMIGRATION_DESC",
    IsLockedByDefault = true,
    Hidden = true,
    DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 0.0, -- default 30
    AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
    CharacterSetup = {
        DataType = "CHARACTER_SETUP",
        IdleAnimation = "IDLE"
    }
})

mod:override({ Id = "NEWCOMER", CompatibleJobList = { Action = "APPEND", "JOB_ALADDIN_IMMIGRATION" } })
mod:override({ Id = "SERF", CompatibleJobList = { Action = "APPEND", "JOB_ALADDIN_IMMIGRATION" } })
mod:override({ Id = "COMMONER", CompatibleJobList = { Action = "APPEND", "JOB_ALADDIN_IMMIGRATION" } })
mod:override({ Id = "CITIZEN", CompatibleJobList = { Action = "APPEND", "JOB_ALADDIN_IMMIGRATION" } })



-- Quest ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "QUEST",
    Id = "QUEST_ALADDIN_IMMIGRATION",
    Name = "QUEST_ALADDIN_IMMIGRATION_NAME",
    Description = "QUEST_ALADDIN_IMMIGRATION_DESC",
    IsSilent = true,
    QuestFunction = {
        DataType = "QUEST_FUNCTION_ASSIGN_WORKER",
        Job = "JOB_ALADDIN_IMMIGRATION",
    },
    QuestRewardList = {
        {
            DataType = "QUEST_REWARD_IMMIGRATION_WAVE",
        },
        {
            DataType = "QUEST_REWARD_IMMIGRATION_WAVE",
        },
        {
            DataType = "QUEST_REWARD_IMMIGRATION_WAVE",
        },
    },
    QuestFailList = nil,
    QuestListToUnlockAfter = nil,
    OnFailCallback = nil,
    OnSuccessCallback = {
        DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
        Event = "EVENT_ALADDIN_IMMIGRATION"
    },
})


-- Default Balancing (event list) ---------------------------------------------------------------------------------------------
mod:override({
    Id = "DEFAULT_BALANCING",
    EventList = {
        Action = "APPEND",
        "EVENT_ALADDIN_IMMIGRATION_SETUP",
    },
})


-- Event: Setup Outlaw ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "EVENT",
    Id = "EVENT_ALADDIN_IMMIGRATION_SETUP",
    Title = "EVENT_ALADDIN_IMMIGRATION_SETUP_NAME",
    Description = "EVENT_ALADDIN_IMMIGRATION_SETUP_DESC",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = false,
    DaysToFirst = 1, -- number of days from the start of the game (setting = 5 will fire the event at the start of Day 5). 
    ConditionList = {
        {
            DataType = "EVENT_CONDITION_BUILDING_BUILT",
            AssetBuilding = "BUILDING_VILLAGE_CENTER"
        }
    },
    ActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_ALADDIN_IMMIGRATION"
        },
    }
})


-- Event: Immigrate ---------------------------------------------------------------------------------------------------------------
mod:register({
    DataType = "EVENT",
    Id = "EVENT_ALADDIN_IMMIGRATION",
    Title = "EVENT_ALADDIN_IMMIGRATION_NAME",
    Description = "EVENT_ALADDIN_IMMIGRATION_DESC",
    IsInMainPool = false,
    IsRecurrent = true,
    DaysToFirst = 1,
    ConditionList = {
    },
    ActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_ALADDIN_IMMIGRATION"
        },
    }
})
